
local QuestID
local QuestLBs
local AnnounceTime = 0
local Description = {}
local Type = {}
local Complete = {}
local DescriptionEnd = {}
local TypeEnd = {}
local CompleteEnd = {}
local Loaded = 0

local frame = CreateFrame("FRAME");
frame:RegisterEvent("PLAYER_ENTERING_WORLD");
frame:RegisterEvent("QUEST_WATCH_UPDATE");
frame:RegisterEvent("QUEST_LOG_UPDATE");
local function eventHandler(self, event, maybeQuestID, ...)
	if event == "PLAYER_ENTERING_WORLD" then
		if Loaded == 0 then
			print("Objective Announcer Active")
			Loaded = 1
		end
	elseif event == "QUEST_WATCH_UPDATE" then
		QuestID = maybeQuestID
		AddQuestWatch(QuestID)
		QuestLBs = GetNumQuestLeaderBoards(QuestID)
		if QuestLBs > 0 then
			for i = 1, QuestLBs do
				Description[i], Type[i], Complete[i] = GetQuestLogLeaderBoard(i, QuestID)
			end
			AnnounceTime = 1
		end
	elseif event == "QUEST_LOG_UPDATE" then
		if AnnounceTime == 1 then
			QuestLBs = GetNumQuestLeaderBoards(QuestID)
			if QuestLBs > 0 then
				for i = 1, QuestLBs do
					DescriptionEnd[i], TypeEnd[i], CompleteEnd[i] = GetQuestLogLeaderBoard(i, QuestID)
					if Complete[i] ~= CompleteEnd[i] then
						local link = GetQuestLink(QuestID)
						local message = strjoin("  --  ", DescriptionEnd[i], link)
						SendChatMessage(message, "PARTY", nil, nil)
					end
				end
				AnnounceTime = 0
			end
		end
	end
end
frame:SetScript("OnEvent", eventHandler);
